/* 
 * File:   keypad_lcd.c
 * Author: chengo_cc
 *
 * Created on 12 April 2016, 11:23 AM
 */

#include <stdio.h>
#include <stdlib.h>
#include <pic.h>
#include "delay.h"
//--------------------------------Keypad port-----------------------------------
#define keypadPort     PORTD
#define KeypadPort_dir TRISD
//--------------------------------4 Rows----------------------------------------
#define row0 RD0
#define row1 RD1
#define row2 RD2
#define row3 RD3
//--------------------------------3 Columns-------------------------------------
/*These codes are used for scanning the columns of the keypad for a Press.
  A Press = HIGH (For this design. Alternatively, LOW can be used if so wished)*/
char column0 = 0x10;       // Column 0 HIGH: RD7 = 0 RD6 = 0 , RD5 = 0 , RD4 = 1
char column1 = 0x20;       // Column 1 HIGH: RD7 = 0 RD6 = 0 , RD5 = 1 , RD4 = 0
char column2 = 0x40;       // Colmun 2 HIGH: RD7 = 0 RD6 = 1 , RD5 = 0 , RD4 = 0
char column3 = 0x80;       // Colmun 3 HIGH: RD7 = 1 RD6 = 0 , RD5 = 0 , RD4 = 0
//------------------------------------------------------------------------------
#include "kpad4x4.h"
//-------------------------LCD module connections-------------------------------
#define RS      RB2         //Register Select
#define EN      RB3         //Enable
#define D4      RB4         //Data pins D4 - D7
#define D5      RB5
#define D6      RB6
#define D7      RB7
//---------------------------DIRECTION------------------------------------------
#define RS_dir  TRISB2
#define EN_dir  TRISB3
#define D4_dir  TRISB4
#define D5_dir  TRISB5
#define D6_dir  TRISB6
#define D7_dir  TRISB7
//------------------------------------------------------------------------------
#include "lcd4bit.h"
//------------------------------------------------------------------------------
int main(int argc, char** argv)
{
  keypad_init();
  LCD_init();
  char character[] = "c1470258=369+-x/";

  while(1)
  {
    char digit = keypad_scan();
    if( digit != ' ' )
    {
      LCD_character(0,0,character[digit]);
    }
    delay(40);
  }

  return (EXIT_SUCCESS);
}
//------------------------------------------------------------------------------